/*
 * Blockdaemon REST API
 *
 * Blockdaemon REST API provides a RESTful and uniform way to access blockchain resources, with a rich and reusable model across multiple protocols/cryptocurrencies.  [Documentation](https://docs.blockdaemon.com/reference/rest-api-overview)  ### Currently supported protocols:  * algorand   * mainnet * avalanche    * mainnet-c/testnet-c * bitcoin   * mainnet/testnet * bitcoincash   * mainnet/testnet * dogecoin   * mainnet/testnet * ethereum   * mainnet/holesky/sepolia * fantom   * mainnet/testnet * litecoin   * mainnet/testnet * near   * mainnet * optimism   * mainnet * polkadot   * mainnet/westend * polygon   * mainnet/amoy * solana   * mainnet/testnet * stellar   * mainnet/testnet * tezos   * mainnet * tron   * mainnet/nile * xrp   * mainnet  ### Pagination Certain resources contain a lot of data, more than what's practical to return for a single request. With the help of pagination, the data is split across multiple responses. Each response returns a subset of the items requested, and a continuation token.  To get the next batch of items, copy the returned continuation token to the continuation query parameter and repeat the request with the new URL. In case no continuation token is returned, there is no more data available.
 *
 * API version: 3.0.0
 * Contact: support@blockdaemon.com
 */

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package ubiquity

import (
	"encoding/json"
)

// UnsignedTxMeta Any extra information relevant regarding the created transaction.
type UnsignedTxMeta struct {
	// The transaction fee.
	Fee *string `json:"fee,omitempty"`
	// The signing payload of the transaction.
	SigningPayload *string `json:"signing_payload,omitempty"`
}

// NewUnsignedTxMeta instantiates a new UnsignedTxMeta object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewUnsignedTxMeta() *UnsignedTxMeta {
	this := UnsignedTxMeta{}
	return &this
}

// NewUnsignedTxMetaWithDefaults instantiates a new UnsignedTxMeta object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewUnsignedTxMetaWithDefaults() *UnsignedTxMeta {
	this := UnsignedTxMeta{}
	return &this
}

// GetFee returns the Fee field value if set, zero value otherwise.
func (o *UnsignedTxMeta) GetFee() string {
	if o == nil || o.Fee == nil {
		var ret string
		return ret
	}
	return *o.Fee
}

// GetFeeOk returns a tuple with the Fee field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *UnsignedTxMeta) GetFeeOk() (*string, bool) {
	if o == nil || o.Fee == nil {
		return nil, false
	}
	return o.Fee, true
}

// HasFee returns a boolean if a field has been set.
func (o *UnsignedTxMeta) HasFee() bool {
	if o != nil && o.Fee != nil {
		return true
	}

	return false
}

// SetFee gets a reference to the given string and assigns it to the Fee field.
func (o *UnsignedTxMeta) SetFee(v string) {
	o.Fee = &v
}

// GetSigningPayload returns the SigningPayload field value if set, zero value otherwise.
func (o *UnsignedTxMeta) GetSigningPayload() string {
	if o == nil || o.SigningPayload == nil {
		var ret string
		return ret
	}
	return *o.SigningPayload
}

// GetSigningPayloadOk returns a tuple with the SigningPayload field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *UnsignedTxMeta) GetSigningPayloadOk() (*string, bool) {
	if o == nil || o.SigningPayload == nil {
		return nil, false
	}
	return o.SigningPayload, true
}

// HasSigningPayload returns a boolean if a field has been set.
func (o *UnsignedTxMeta) HasSigningPayload() bool {
	if o != nil && o.SigningPayload != nil {
		return true
	}

	return false
}

// SetSigningPayload gets a reference to the given string and assigns it to the SigningPayload field.
func (o *UnsignedTxMeta) SetSigningPayload(v string) {
	o.SigningPayload = &v
}

func (o UnsignedTxMeta) MarshalJSON() ([]byte, error) {
	toSerialize := map[string]interface{}{}
	if o.Fee != nil {
		toSerialize["fee"] = o.Fee
	}
	if o.SigningPayload != nil {
		toSerialize["signing_payload"] = o.SigningPayload
	}
	return json.Marshal(toSerialize)
}

type NullableUnsignedTxMeta struct {
	value *UnsignedTxMeta
	isSet bool
}

func (v NullableUnsignedTxMeta) Get() *UnsignedTxMeta {
	return v.value
}

func (v *NullableUnsignedTxMeta) Set(val *UnsignedTxMeta) {
	v.value = val
	v.isSet = true
}

func (v NullableUnsignedTxMeta) IsSet() bool {
	return v.isSet
}

func (v *NullableUnsignedTxMeta) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableUnsignedTxMeta(val *UnsignedTxMeta) *NullableUnsignedTxMeta {
	return &NullableUnsignedTxMeta{value: val, isSet: true}
}

func (v NullableUnsignedTxMeta) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableUnsignedTxMeta) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}
